// =======================================================================
//  This software is the property of Precise Automation and can be freely
//  copied and used by Precise's customers so long as this notice is
//  included with any modified or unmodified version of this software.
// =======================================================================

/* Set of functions used to automatically scan and update the robot/controller
   status system prompts will be supported.*/
	var xmlHttpStt
	var timesStt = setInterval("updatePower()",1000);

	var updatetoggle = false
	var tId 

	function disUpdate(){
		if(tId){
			clearInterval(tId);
		}
		tId=setInterval("showDisconnect()",5000)
		gplActive = true
		var ctable = document.getElementById("tblComm")
			if(ctable!=null){
				var sOut = ""
				ctable.rows[0].cells[0].style.textAlign = "right";
				ctable.rows[0].cells[0].style.fontWeight="normal";		
				ctable.rows[0].cells[0].style.backgroundColor="";
				ctable.rows[0].cells[0].innerHTML= sOut;
		}
	}
	function showDisconnect(){
			var ctable = document.getElementById("tblComm")
			if(ctable!=null){
				sOut = "*Warning* panel not refreshing"
				ctable.rows[0].cells[0].style.backgroundColor="Yellow";
				ctable.rows[0].cells[0].style.fontWeight="Bold";		
				ctable.rows[0].cells[0].style.textAlign = "center";
				ctable.rows[0].cells[0].innerHTML= sOut;
			}
			clearInterval(tId);
	}

	function updatePower(){
		xmlHttpStt=new ActiveXObject("Microsoft.XMLHTTP")
		var url="/flash/appweb/shared/powerrefresh.asp";
		xmlHttpStt.onreadystatechange=stateChange
		xmlHttpStt.open("GET",url,true)
		xmlHttpStt.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" );
		xmlHttpStt.send(null)
	}
	
	function stateChange(){
		if (xmlHttpStt.readyState==4 || xmlHttpStt.readyState=="complete"){
			var stt = new Array();
			stt = xmlHttpStt.responseText.split(",")
			updateState(stt[0],stt[1]);
			disUpdate();
		}
	}

function updateState(pStateIdx,homeStt){
	var StateTab = document.getElementById("StateTab")
	var pState = new Array(60)
	var pColor = new Array(60)

	pState[0] = "System initializing"
	pColor[0] = "White"
	pState[1] = "Fatal error"
	pColor[1] = "Red"
	pState[2] = "Restarting"
	pColor[2] = "White"
	pState[3] = "Turning off power"
	pColor[3] = "Yellow"
	pState[4] = "Turning off power"
	pColor[4] = "Yellow"
	pState[5] = "Off: fault occurred"
	pColor[5] = "Red"
	pState[6] = "Off: switch off wait"
	pColor[6] = "White"
	pState[7] = "Off: switch on wait"
	pColor[7] = "White"
	pState[8] = "Enabling power #1"
	pColor[8] = "Yellow"
	pState[9] = "Commutating motors"
	pColor[9] = "Yellow"
	pState[10] = "Enabling power #2"
	pColor[10] = "Yellow"
	pState[11] = "On: auto mode wait"
	pColor[11] = "Aqua"
	pState[12] = "On: auto mode run"
	pColor[12] = "lightgreen"
	pState[15] = "E-stop asserted"
	pColor[15] = "Red"
	pState[20] = "GPL ready"
	pColor[20] = "Aqua"
	pState[21] = "GPL executing"
	pColor[21] = "lightgreen"
	pState[22] = "MotionBlocks exec"
	pColor[22] = "lightgreen"
	pState[23] = "AIO velocity exec "
	pColor[23] = "lightgreen"
	pState[24] = "AIO torque exec   "
	pColor[24] = "lightgreen"
	pState[25] = "Master/slave exec"
	pColor[25] = "lightgreen"
	pState[26] = "CAN net executing"
	pColor[26] = "lightgreen"
	pState[27] = "CAN serial exec"
	pColor[27] = "lightgreen"
	pState[28] = "Robot Homing"
	pColor[28] = "Yellow"
	pState[29] = "Jog Mode Active"
	pColor[29] = "Yellow"
	pState[30] = "Ext traj exec"
	pColor[30] = "lightgreen"
	pState[31] = "MCP Active"
	pColor[31] = "white"
	
	StateTab.rows[0].cells[1].innerHTML = pState[pStateIdx];
	StateTab.rows[0].cells[1].bgColor=pColor[pStateIdx];
	StateTab.rows[0].cells[1].className="sBorder";
	StateTab.rows[0].cells[1].style.textAlign="center";

	StateTab.rows[1].cells[1].innerHTML = homeStt;
	StateTab.rows[1].cells[1].style.textAlign="center";
	
}

